package com.hzya.frame.plugin.lets.dingtalk.push.serivce.impl;

import cn.hutool.core.lang.Assert;
import com.hzya.frame.plugin.lets.dingtalk.push.serivce.PushU8CService;
import com.hzya.frame.plugin.lets.dingtalk.vo.DjFileVO;
import com.hzya.frame.plugin.lets.dingtalk.vo.DjzbVO;
import com.hzya.frame.plugin.lets.dingtalk.vo.SysFileVO;
import com.hzya.frame.plugin.lets.plugin.adjust.AdjustInPluginInitializer;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.stereotype.Service;

import java.io.File;
import java.util.ArrayList;
import java.util.Base64;
import java.util.List;

/**
 * u8c单据推送钉钉表单
 * fileBase64s为文件转了base64之后
 */
@Service("PushU8CService")
public class PushU8CServiceImpl implements PushU8CService {

    Logger logger = LoggerFactory.getLogger(PushU8CServiceImpl.class);


    /** 委外采购（付款单）->采购付款申请(新) */
    @Override
    public String outSource(DjFileVO djFileVO) {
        checkParameter(djFileVO);
        System.out.println(djFileVO);
        try{
            //

        }catch (Exception e){
            e.printStackTrace();
            logger.error("委外采购（付款单）->采购付款申请（新）报错",e);
        }
        return "110";
    }

    /** 代理采购（付款单）->采购付款申请(店群专用) */
    @Override
    public String agency(DjFileVO djFileVO) {
        checkParameter(djFileVO);
        return null;
    }

    /** 调拨单内部交易（付款单）->特殊业务处理(新) */
    @Override
    public String transfer(DjFileVO djFileVO) {
        checkParameter(djFileVO);
        return null;
    }

    /**
     * 检查参数，VO不能为空，文件不能空
     * @param djFileVO:djzbVO+sysFileVOS
     */
    public void checkParameter(DjFileVO djFileVO){
        Assert.notNull(djFileVO.getDjzbVO(),"u8c单据推送钉钉表单,检查参数，VO不能为空");
        if (djFileVO.getSysFileVOS().size() == 0) {
            Assert.state(false,"u8c单据推送钉钉表单,检查参数，文件不能空");
        }
    }

    /**
     * 文件转换
     * 将base64转为文件上传钉盘，并返回钉钉的 List<FileModuleVO>
     * @return
     */
    public List<File> baseTransformFile(List<SysFileVO> fileBase64s){
        List<File> fileList=new ArrayList<>();
//        for (String fileBase64 : fileBase64s) {
//            // 解码Base64字符串
//            byte[] decodedBytes = Base64.getDecoder().decode(fileBase64);
//        }
        return fileList;
    }
}
